#!/bin/bash
#
# (C) 2006 Marek Wodzinski
# http://majek.mamy.to
#
# Make calibration file for ladowarka.sh - 1-wire Li-Ion charger
#
# Usage: cat ladowarka.cal.in | ./cal.sh >ladowarka.cal

x1=
y1=
x2=
y2=

while read linijka; do
  linijka=`echo "$linijka"|grep -vE "^#"|tr "[:space:]" " "|tr -s " "`
  if [ "$linijka" ]; then
    if [ -z "$x1" ]; then
      y1=`echo "$linijka"|cut -f 1 -d ' '`
      x1=`echo "$linijka"|cut -f 2 -d ' '`
    else
      y2=`echo "$linijka"|cut -f 1 -d ' '`
      x2=`echo "$linijka"|cut -f 2 -d ' '`
      
      a=`echo -e "scale=6\n($y2-$y1)/($x2-$x1)\n"|bc`
      b=`echo -e "scale=6\n$y1-$a*$x1\n"|bc`
      
      x10k=`echo -e "10000*$x2\n"|bc|cut -f 1 -d '.'`
      echo "$x10k:$a:$b"
    fi
  fi
done
